<?php
require_once "./lib/nusoap.php";
@session_start();
/**
 * BoxBilling
 *
 * LICENSE
 *
 * This source file is subject to the license that is bundled
 * with this package in the file LICENSE.txt
 * It is also available through the world-wide-web at this URL:
 * http://www.boxbilling.com/LICENSE.txt
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@boxbilling.com so we can send you a copy immediately.
 *
 * @copyright Copyright (c) 2010-2012 BoxBilling (http://www.boxbilling.com)
 * @license   http://www.boxbilling.com/LICENSE.txt
 * @version   $Id$
 * @author Morteza Saheb 09141776345
 */
class Payment_Adapter_ePayBank extends Payment_AdapterAbstract
{
public function _send($api,$amount,$redirect){
$client=new nusoap_client("http://epaybank.ir/secure_gateway/ariacoders.php");
$error=$client->getError();
if($error){
echo "<h2>Constructor Error</h2><pre>".$error."</pre>";
}
//$_SESSION["price"]=$amount;
$orderid=date('ymdhis');
$result=$client->call("requestpayment",array($api,$redirect,$amount,"parsian",$orderid));
$client->soap_defencoding = 'UTF-8';
if($client->fault){
	//echo "<h2>Fault</h2><pre>";
	return $result;
	//echo "</pre>";
}
else
{
$error=$client->getError();
	if($error)
	{
		return $error;
	}
	else
	{
		
		return $result;
		
	}
}///===================================
    }
public function _get($api,$price,$rs){
	$value=trim($price);
	if(preg_match('/^[0-9]*$/',$value))
	{
	$client=new nusoap_client("http://epaybank.ir/secure_gateway/ariacoders.php");
	$client->soap_defencoding = 'UTF-8';

	$error=$client->getError();
	if($error){
	echo "<h2>Constructor Error</h2><pre>".$error."</pre>";
	}
	$result=$client->call("verifypeyment",array($api,$value,$rs,"parsian"));
	$client->soap_defencoding = 'UTF-8';

	if($client->fault){
		//echo "<h2>Fault</h2><pre>";
		return $result;
		//echo "</pre>";
	}
	else
	{
	$error=$client->getError();
		if($error){
			 return $error;
		}
		else
		{
			return $result;
		
		}
	}
	}//if first	
    }
    public $go_url;
    public function init()
    {

        if (!$this->getParam('securityCode')) {
        	throw new Payment_Exception('Payment gateway "ePayBank" is not configured properly. Please update configuration parameter "API Key Code" at "Configuration -> Payments".');
        }
    }

    public static function getConfig()
    {
        return array(
            'supports_one_time_payments'   =>  true,
            'supports_subscriptions'     =>  false,
            'description'     =>  'Clients will be redirected to ePayBank.ir to make payment.<br />' ,
            'form'  => array(
                 'securityCode' => array('text', array(
                 			'label' => 'API Key Code',
                 			'description' => 'To setup your "API Key Code" login to ePayBank account. Go to LINK "http://ePayBank.ir/user/gateway-list". Copy "API Key Code" and paste it to this field.',
                 			'validators' => array('notempty'),
                 	),
                 ),
            ),
        );
    }

    /**
     * Return payment gateway type
     * @return string
     */
    public function getType()
    {
        return Payment_AdapterAbstract::TYPE_FORM;
    }

    /**
     * Return payment gateway type
     * @return string
     */
    public function getServiceUrl()
    {
        if($this->testMode) {
            return 'http://ePayBank.ir/';
        }
		return $this->go_url;
    }

    /**
     * Init call to webservice or return form params
     * @param Payment_Invoice $invoice
     */
	public function singlePayment(Payment_Invoice $invoice)
	{
     
        $api = $this->getParam('securityCode');
        $amount = (int)$invoice->getTotalWithTax();
        $redirect = urlencode($this->getParam('redirect_url'));

        $result = $this->_send($api,$amount,$redirect);
	$_SESSION["price"]=$amount;
        if(filter_var($result, FILTER_VALIDATE_URL)){
            $this->go_url = $result;
        }else{
            throw new Exception('ePayBank error : '.$result);
        }
		echo 'در حال اتصال به درگاه ePayBank <form name="target_two" action="'.$this->go_url.'" method="post"></form>"
		<script language="javascript" type="text/javascript">
				window.onload = document.body.onload = function () {
						setTimeout("ettesal()", 1000);
				}
				function ettesal() {
					document.forms["target_two"].submit();
				}
		
			</script>';

        return $data;
	}

    /**
     * Perform recurent payment
     */
	public function recurrentPayment(Payment_Invoice $invoice)
	{
		throw new Payment_Exception('Not implemented yet');
	}

    /**
     * Handle IPN and return response object
     * @return Payment_Transaction
     */
	public function getTransaction($data, Payment_Invoice $invoice)
	{
        $ipn = $data['post'];

        $Pay_Status             = 'FAIL';

        $api = $this->getParam('securityCode');
        $rs = $_GET['rs'];
        $price = $_SESSION["price"];
       


		$result = $this->_get($api,$price,$rs);
        $VerifyAnswer = $result->return;
        error_log('Verify answer:' . $VerifyAnswer);

        if($result == '-33'){
            $Pay_Status = 'OK';
        }

        if ($Pay_Status != 'OK' ){
            throw new Payment_Exception('Sale verification failed: '.$VerifyAnswer);
        }

        $response = new Payment_Transaction();
        $response->setType(Payment_Transaction::TXTYPE_PAYMENT);
        $response->setId($trans_id);
        $response->setAmount($invoice->getTotalWithTax());
        $response->setCurrency($invoice->getCurrency());
        $response->setStatus(Payment_Transaction::STATUS_COMPLETE);
        return $response;
	}
    /**
     * Check if Ipn is valid
     */
    public function isIpnValid($data, Payment_Invoice $invoice)
    {
        $ipn = $data['post'];
        return true;
    }
}
